#!/bin/bash
#

#EX_DIR=/home/ghaase/Lectures/SciComp/Try/myvector_ext
EX_DIR=${PWD}

# go to directory
cd ${EX_DIR}

#########################################################################
# there must be a Matlab file somewhere
find .. -name "*.m"

pushd ../BinaryMatrix/

octave read_crs.m

popd                     # back to original dir

pwd

#########################################################################
#         make and return value of executable
make clean
make -n
make run

ls -altr

#  find the newest executable (according to my name scheme)
PROG=`ls -tr1 main*_ |tail -1`

#  Command line argument (see also Kurs-C/Beispiele/FileIO_d.cpp)
./${PROG} 66

## Did code return 0 ?

./${PROG} 66 && echo "Erfolgreich"
./${PROG} 66 || (echo "  "; echo "Nicht Erfolgreich"; echo "  "; )

./${PROG} 10000000000 && echo "Erfolgreich"
./${PROG} 10000000000 || (echo "  "; echo "Nicht Erfolgreich"; echo "  "; )

#########################################################################
# Ausgabe und Eingabeumlenkung
INPUT_FILE=in.txt
ERR_FILE=err.txt
OUT_FILE=out.txt

# Input Stream (stdin) and Error Stream (stderr)
./${PROG} <${INPUT_FILE} 2>${ERR_FILE} || (echo "  "; echo "Nicht Erfolgreich"; echo "  "; geany ${ERR_FILE}& )

# only Output Stream (stdout)
./${PROG} 66 >${OUT_FILE} && (echo "  "; echo "Erfolgreich"; echo "  "; geany ${OUT_FILE}& )

# Error and Output Stream to  o n e  file
./${PROG} 3  &>${OUT_FILE}

#  Error and Output Stream to  different files
./${PROG} 3  2>${ERR_FILE} 1>${OUT_FILE}

# Pipelining of stdout : becomes stdin for second call
 ./${PROG} 3 | grep -i myvector

# see also        http://stackoverflow.com/questions/2342826/how-to-pipe-stderr-and-not-stdout




