#ifndef MYMATRIX_H_INCLUDED
#define MYMATRIX_H_INCLUDED

class MyMatrix: public MyVector
{
public:
    MyMatrix(const int nrow, const int ncol)
    : MyVector(static_cast<long long>(nrow)*ncol), nrow_(nrow), ncol_(ncol) {}

    ~MyMatrix() {}

    //! \brief Returns the value of element @p i.
    //!
    //! \param[in] i     index
    //! \return          value
    //! \warning Throws an exception "OutOfRange" in case an invalid index @p i.
    //!
    double* operator[](const int i)
    {
        return val_+i*nrow_;
    }

    //! \brief Returns the value of element @p i.
    //!
    //! \param[in] i     index
    //! \return          value
    //! \warning Throws an exception "OutOfRange" in case an invalid index @p i.
    //!
    const double* operator[](const int i) const		// const notw. fuer const. Instanzen von MyVektor
    {
        return val_+i*nrow_;
    }

    int Rows() const {return nrow_;}
    int Cols() const {return ncol_;}


private:
          int nrow_;  //!< number of matrix rows
          int ncol_;  //!< number of matrix columns
};


#endif // MYMATRIX_H_INCLUDED
